;--------------------------------
;Package information

   ;Package name
   !define PACKAGE_NAME "RCSFWD"

   ;Package version
   !define /file PACKAGE_VERSION "..\VERSION"

;--------------------------------
;General

   ;Name and file
   Name "${PACKAGE_NAME}"
   OutFile "${PACKAGE_NAME}-${PACKAGE_VERSION}.exe"

   ;Default installation folder
   InstallDir "C:\${PACKAGE_NAME}\"

   ;Interface
   !include "MUI2.nsh"
   !define MUI_ABORTWARNING
   !define MUI_WELCOMEFINISHPAGE_BITMAP "HT.bmp"
   !define MUI_WELCOMEFINISHPAGE_BITMAP_NOSTRETCH
   !define MUI_ICON "HT.ico"
   !define MUI_UNICON "HT.ico"
   ShowInstDetails "show"
   ShowUninstDetails "show"

   ;Installer pages
   !insertmacro MUI_PAGE_WELCOME
   !insertmacro MUI_PAGE_INSTFILES

   ;Uninstaller pages
   !insertmacro MUI_UNPAGE_WELCOME
   !insertmacro MUI_UNPAGE_INSTFILES

   ;Language
   !insertmacro MUI_LANGUAGE "English"

;--------------------------------
;Sections

Section "Install Section" SecInstall

   !system 'cl /Fe..\bin\RCSFWD.exe ..\src\RCSFWD.c advapi32.lib'
   !system 'del RCSFWD.obj'
   !system 'rcscrypt ..\src\RCSFWD.php ..\bin\RCSFWD.php'

   SetOutPath "$INSTDIR"

   File /r /x "*.nsi" /x "${PACKAGE_NAME}-*.exe" /x "HT.bmp" /x "rcscrypt.*" "..\setup"
   File /r "..\bin"
   File "..\VERSION"

   !system 'del /q ..\bin\*.*'

   WriteUninstaller "$INSTDIR\setup\${PACKAGE_NAME}-uninstall.exe"

   WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PACKAGE_NAME}" "DisplayName" "${PACKAGE_NAME}"
   WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PACKAGE_NAME}" "DisplayIcon" "$INSTDIR\setup\HT.ico"
   WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PACKAGE_NAME}" "DisplayVersion" "${PACKAGE_VERSION}"
   WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PACKAGE_NAME}" "UninstallString" "$INSTDIR\setup\${PACKAGE_NAME}-uninstall.exe"
   WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PACKAGE_NAME}" "NoModify" 0x00000001
   WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PACKAGE_NAME}" "NoRepair" 0x00000001

SectionEnd

Section "Setup Section" SecSetup

   nsExec::ExecToLog 'C:\RCSFWD\bin\RCSFWD --install'
   nsExec::ExecToLog 'net start RCSFWD'

SectionEnd

Section Uninstall

   nsExec::ExecToLog 'net stop RCSFWD'
   nsExec::ExecToLog 'C:\RCSFWD\bin\RCSFWD --uninstall'

   RMDir /r "C:\${PACKAGE_NAME}"

   DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PACKAGE_NAME}"

SectionEnd

;--------------------------------
;Functions

Function .onInit

   IfFileExists "C:\RCSDB\VERSION" +3 0
      MessageBox MB_ICONSTOP "You need RCSDB in order to install RCSFWD"
      Abort

   Return

FunctionEnd
